#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LEFT_CHILD(i)   (((i) * 2) + 1)
#define RIGHT_CHILD(i)  (((i) * 2) + 2)
#define PARENT(i)       (((i) - 1) / 2)
#define INIT_SIZE 2
typedef int (*prioq_compare_t)(struct prioq_head *a, struct prioq_head *b);

struct prioq_head{
	    int index;
};		

struct user_data{
        struct prioq_head head;
		int data;
};		

struct prioq{
        struct prioq_head **heap;
	    size_t size;
        size_t used;
        prioq_compare_t compare;
};	

/* */
int compare(struct prioq_head *a, struct prioq_head *b){
    struct user_data *ap = (struct user_data*)a;
	struct user_data *bp = (struct user_data*)b;
	
	if (ap->data > bp->data){
	 	return 1;
	};
	
	if (ap->data == bp->data){
		return 0;
	};
	
	if (ap->data < bp->data){
		return -1;
	}
}


/*  */
struct prioq
*prioq_new(prioq_compare_t compare){
	    
    struct prioq *queue;
	struct prioq_head **hp;
 
	queue = (prioq *)malloc(sizeof(struct prioq));
	
	memset(queue,0,sizeof(struct prioq));//clear
	hp = (prioq_head**)malloc(INIT_SIZE*(sizeof(struct prioq_head*)));
	memset(hp,0,sizeof(struct prioq));//clear
	
	
	if (queue == NULL) {
		fprintf(stderr, "prioq_new(): out of memory !\n");
		return NULL;
	}	
    
	queue-> heap = hp;
	queue->size = INIT_SIZE;
	queue->used = 0;	
	queue->compare = compare;
	
	return queue;
}		
/*  */
int prioq_put(struct prioq *queue, struct prioq_head *hp){

    int i;
	struct user_data *heap_data_1,*heap_data_2;
	struct user_data *insert_data = (struct user_data*)hp;
	//grow_heap
	if (queue->size == queue->used) {
		       	queue->size = queue->size + 1;
		        queue->heap = (struct prioq_head**)realloc(queue->heap,(queue->size+1)*sizeof(struct prioq_head*));
	            				
				if (queue->heap == NULL){
					fprintf(stderr, "queue_insert(): out of memory !\n");
	            }	
	};
	
    i = queue->used;
  	
	while (i and (heap_data_1->data < insert_data->data)) {
        heap_data_1 = (struct user_data *)queue->heap[i];
	    heap_data_2 = (struct user_data *)queue->heap[PARENT(i)];   	
		heap_data_1 = heap_data_2;
		i = PARENT(i);
	}	
	
	queue->used = queue->used + 1;
	queue->heap[i] = hp;

}	

	
				
int main(void){
    struct prioq *q=prioq_new(compare); 
    struct user_data a,b,c;
	struct prioq_head *p,*s,*t;
		
    a.data = 0;
    b.data = 5;
	c.data = 1;
	p = &a.head;
	s = &b.head;
	t = &c.head;
	
	
	prioq_put(q,p);
	prioq_put(q,s);
	prioq_put(q,t);
	
	//compare(q->heap[0],q->heap[1]);

	return q->size;	
}
  	

	